'From Squeakland 3.8-05 of 1 September 2005 [latest update: #527] on 6 November 2006 at 4:52:15 pm'!

!DamaUtil class methodsFor: 'as yet unclassified' stamp: 'ko 11/6/2006 16:52'!
isKotodamaPhraseTileMorph: morph

	^( (morph isKindOf: PhraseTileMorph) 
		or: [ morph isKindOf: DamaCompoundTileMorph ] )
		or: [ morph isKindOf: DamaRandomTile ]! !


!Morph methodsFor: 'testing' stamp: 'ko 11/6/2006 16:40'!
shouldDropOnMouseUp
	| t1 |

	( DamaUtil isKotodamaPhraseTileMorph: self )
		ifTrue: [ ^false ].

	t1 := self formerPosition
				ifNil: [^ false].
	^ (t1 dist: self position)
		> 10! !


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'ko 11/6/2006 16:27'!
dropMorph: t1 event: t2 
	| t3 t4 |
	(t2 isMouseUp
			and: [t1 shouldDropOnMouseUp not])
		ifTrue: [^ self].
	self privateRemove: t1.
	t1 privateOwner: self.
	t4 := t1.
	(t4 hasProperty: #addedFlexAtGrab)
		ifTrue: [t4 := t1 removeFlexShell].
	t3 := DropEvent new
				setPosition: self position
				contents: t4
				hand: self.
	self sendEvent: t3 focus: nil.
	t3 wasHandled
		ifFalse: [t1 rejectDropMorphEvent: t3].
	t1 owner == self
		ifTrue: [t1 delete].
	self mouseOverHandler processMouseOver: t2! !

!HandMorph methodsFor: 'grabbing/dropping' stamp: 'ko 11/6/2006 16:39'!
grabMorph: t1 from: t2 
	| t3 t4 t5 t6 t7 |

"Transcript show: '.' ; cr."
"self halt."

	self releaseMouseFocus.
	t3 := t1.
	t1 keepsTransform
		ifTrue: [t6 := t7 := IdentityTransform new]
		ifFalse: [t6 := t2
						ifNil: [IdentityTransform new]
						ifNotNil: [t2 grabTransform].
			t7 := t2
						ifNil: [IdentityTransform new]
						ifNotNil: [t2 transformFrom: owner]].
	t5 := t7 globalPointToLocal: self position.
	t4 := t5
				- (t6 globalPointToLocal: self position).
	t3 := t3 transformedBy: t6.
	t3 == t1
		ifFalse: [t3 setProperty: #addedFlexAtGrab toValue: true].
	
	t3 position: t3 position - t4 asIntegerPoint.

	( DamaUtil isKotodamaPhraseTileMorph: t1 ) ifTrue: [
		t3 position: ( self position x - 5 ) @ ( self position y - 5 ).
	].

	targetOffset := t3 position - self position.
	self addMorphBack: t3.
	t3 justGrabbedFrom: t2! !

