﻿'From Squeakland 3.8-05 of 1 September 2005 [latest update: #527] on 6 November 2006 at 3:44:41 pm'!

!DamaBooleanPhraseTile methodsFor: 'as yet unclassified' stamp: 'ko 11/6/2006 15:37'!
changeToSentenceView

	( (self lastSubmorph isKindOf: StringMorph) and: 
		[ self lastSubmorph contents = 'かどうか' ] ) ifTrue: [
		self removeMorph: self lastSubmorph
	].!]lang[(107 4 57)0,5,0! !

!DamaBooleanPhraseTile methodsFor: 'as yet unclassified' stamp: 'ko 11/6/2006 15:30'!
mouseDown: evt

	| |

"	owner ifNotNil: [
		owner owner ifNotNil: [

			(self ownerThatIsA: DamaBooleanScriptEditor) ifNotNil: [
				(self ownerThatIsA: DamaCompoundTileMorph) isEmpty ifTrue: [
					(self ownerThatIsA: DamaCompoundTileMorph) removeMySelf.
				].
				booleanScriptEditor _ owner owner.
				owner removeMorph: self.
				booleanScriptEditor initializeView.
				self changeToNounView.
				^evt hand grabMorph: self.
			].
	]]."

	^super mouseDown: evt.
! !


!DamaValueTileMorph methodsFor: 'as yet unclassified' stamp: 'ko 11/6/2006 15:29'!
mouseDown: evt

	| |

	"owner ifNotNil: [
		owner owner ifNotNil: [

			( booleanScriptEditor _ self ownerThatIsA: DamaBooleanScriptEditor) ifNotNil: [
				(booleanScriptEditor ownerThatIsA: DamaCompoundTileMorph) isEmpty ifTrue:[
					(booleanScriptEditor ownerThatIsA: DamaCompoundTileMorph) removeMySelf.
				] ifFalse: [
					owner owner removeMorph: self owner.
					booleanScriptEditor initializeView.
				].

				self resultType = #Boolean ifTrue: [
					self changeToSentenceView.
				].

				^evt hand grabMorph: self.
			]

	]]."

	^super mouseDown: evt.
! !


!ScriptEditorMorph methodsFor: 'dropping/grabbing' stamp: 'ko 11/6/2006 15:12'!
acceptDroppingMorph: aMorph event: evt
	"Allow the user to add tiles and program fragments just by dropping them on this morph."

	| i slideMorph p1 p2 |

	self prepareToUndoDropOf: aMorph.
	"Find where it will go, and prepare to animate the move..."
	i _ self rowInsertionIndexFor: aMorph fullBounds center.
	slideMorph _ aMorph imageForm offset: 0@0.
	p1 _ aMorph screenRectangle topLeft.
	aMorph delete.
	self stopSteppingSelector: #trackDropZones.
	self world displayWorld.  "Clear old image prior to animation"

	"(aMorph isKindOf: DamaBooleanPhraseTile) & (aMorph resultType ~= #unknown) ifTrue: [
		compound _ DamaCompoundTileMorph new.
		compound addTestTile: aMorph.
		self insertTileRow: ( Array with: compound ) after: i.
	].
	(aMorph isKindOf: DamaValueTileMorph) & (aMorph resultType ~= #unknown) ifTrue: [
		compound _ DamaCompoundTileMorph new.
		compound addValueTile: aMorph.
		self insertTileRow: ( Array with: compound ) after: i.
	]."
	((( aMorph isKindOf: DamaBooleanPhraseTile ) & (aMorph resultType ~= #unknown) )not) & 
		 ((( aMorph isKindOf: DamaValueTileMorph ) & (aMorph resultType ~= #unknown) )not )
	 ifTrue: [

		(aMorph isKindOf: PhraseTileMorph) ifTrue:
			[aMorph justGrabbedFromViewer: false].
		aMorph tileRows do: [:tileList |
			self insertTileRow: (Array with:
					(tileList first rowOfRightTypeFor: owner forActor: aMorph associatedPlayer))
				after: i.
			i _ i + 1].
	].

	self removeSpaces.
	self enforceTileColorPolicy.
	self layoutChanged.
	self fullBounds. "force layout"

	"Now animate the move, before next Morphic update.
		NOTE: This probably should use ZoomMorph instead"
	p2 _ (self submorphs atPin: (i-1 max: firstTileRow)) screenRectangle topLeft.
	slideMorph slideFrom: p1 to: p2 nSteps: 5 delay: 50 andStay: true.
	self playSoundNamed: 'scritch'.
	self topEditor install  "Keep me for editing, a copy goes into lastAcceptedScript"! !

!ScriptEditorMorph methodsFor: 'dropping/grabbing' stamp: 'ko 11/6/2006 15:25'!
trackDropZones
	"The fundamental heart of script-editor layout, by Dan Ingalls in fall 1997, though many hands have touched it since."

	| hand insertion i space1 d space2 insHt nxtHt prevBot ht2 c1 c2 ii where |

	hand _ handWithTile ifNil: [self primaryHand].
	((self hasOwner: hand) not and: [hand submorphCount > 0])
		ifTrue:
			[
			insertion _ hand firstSubmorph renderedMorph.
			insHt _ insertion fullBounds height.			self removeSpaces.
			where _ self globalPointToLocal: hand position"insertion fullBounds topLeft".
			i _ (ii _ self indexOfMorphAbove: where) min: submorphs size-1.
			prevBot _ i <= 0 ifTrue: [(self innerBounds) top]
							ifFalse: [(self submorphs at: i) bottom].
			nxtHt _ (submorphs isEmpty
				ifTrue: [insertion]
				ifFalse: [self submorphs at: i+1]) height.
			d _ ii > i ifTrue: [nxtHt "for consistent behavior at bottom"]
					ifFalse: [0 max: (where y - prevBot min: nxtHt)].

			"Top and bottom spacer heights cause continuous motion..."
			c1 _ Color green.  c2 _ Color transparent.
			ht2 _ d*insHt//nxtHt.
			space1 _ Morph newBounds: (0@0 extent: 30@(insHt-ht2))
                                        color: ((insHt-ht2) > (insHt//2+1) ifTrue: [c1] ifFalse: [c2]).
			self privateAddMorph: space1 atIndex: (i+1 max: 1).
			space2 _ Morph newBounds: (0@0 extent: 30@ht2)
                                        color: (ht2 > (insHt//2+1) ifTrue: [c1] ifFalse: [c2]).
			self privateAddMorph: space2 atIndex: (i+3 min: submorphs size+1).

			]
		ifFalse:
			[self stopSteppingSelector: #trackDropZones.
			self removeSpaces]! !

!ScriptEditorMorph methodsFor: 'dropping/grabbing' stamp: 'ko 11/6/2006 15:31'!
wantsDroppedMorph: aMorph event: evt
	"Answer whether the receiver would be interested in accepting the morph"

	"(aMorph isKindOf: DamaValueTileMorph) ifTrue: [^true]."

	^ (aMorph isTileLike and: [self isTextuallyCoded not]) and:
		[(#(Command Unknown "Boolean") includes: aMorph resultType capitalized)]! !

!ScriptEditorMorph methodsFor: 'event handling' stamp: 'ko 11/6/2006 15:28'!
mouseEnter: t1 
	| t2 t3 |
	self flag: #bob.
	t2 := t1 hand.
	t2 submorphs size = 1
		ifFalse: [^ self].
	t3 := t2 firstSubmorph renderedMorph.
	(self wantsDroppedMorph: t3 event: t1)
		ifFalse: [^ self].
	handWithTile := t2.
	self startSteppingSelector: #trackDropZones! !


!DamaBooleanScriptEditor methodsFor: 'dropping/grabbing' stamp: 'ko 11/6/2006 15:26'!
wantsDroppedMorph: aMorph event: evt 
	"Answer whether the receiver would be interested in accepting the morph"

"	(submorphs detect: [:m | m isAlignmentMorph] ifNone: [nil]) 
		ifNotNil: [^ false]."

"	(submorphs detect: [:m | m isStringMorph] ifNone: [nil]) 
		ifNotNil: [^ false]."

	"スクリプトを持っているなら、ここにタイルをドロップ出来ない。よってfalseを返す"
	self hasScript ifTrue: [ ^false ].

	((aMorph isKindOf: ParameterTile) and: [aMorph scriptEditor == self topEditor])
		ifTrue: [^ true].
	^ (aMorph isKindOf: PhraseTileMorph orOf: WatcherWrapper) 
		and: [(#(#Command #Unknown) includes: aMorph resultType capitalized) not]!]lang[(288 33 5 3 275)0,5,0,5,0! !


!DamaScriptEditorMorph methodsFor: 'dropping/grabbing' stamp: 'ko 11/6/2006 15:11'!
trackDropZones
	"The fundamental heart of script-editor layout, by Dan Ingalls in fall 1997, though many hands have touched it since."

	| hand insertion i space1 d space2 insHt nxtHt prevBot ht2 c1 c2 ii where |

	hand _ handWithTile ifNil: [self primaryHand].
	((self hasOwner: hand) not and: [hand submorphCount > 0])
		ifTrue:
			[

			"スクリプトを持っていないなら、「ドロップ可能ですよ」という表示をする"
			self hasScript ifFalse:[

				self submorphs first submorphs size = 0 ifTrue: [
					self initializeView.
				].
				self submorphs first submorphs first dropMode.

				"「何もしない」というDamaNopTileMorphを削除する"
				"self removeMorph: ( self submorphs at: 1 )."
				"ドロップ可能なことを図示する（ex.緑色のMorphを追加するなど）"
				"self addMorph: ( Morph newBounds: (0@0 extent: 200@20) color: Color green )."

				^nil.
			].

			insertion _ hand firstSubmorph renderedMorph.
			insHt _ insertion fullBounds height.			self removeSpaces.
			where _ self globalPointToLocal: hand position"insertion fullBounds topLeft".
			i _ (ii _ self indexOfMorphAbove: where) min: submorphs size-1.
			prevBot _ i <= 0 ifTrue: [(self innerBounds) top]
							ifFalse: [(self submorphs at: i) bottom].
			nxtHt _ (submorphs isEmpty
				ifTrue: [insertion]
				ifFalse: [self submorphs at: i+1]) height.
			d _ ii > i ifTrue: [nxtHt "for consistent behavior at bottom"]
					ifFalse: [0 max: (where y - prevBot min: nxtHt)].

			"Top and bottom spacer heights cause continuous motion..."
			c1 _ Color green.  c2 _ Color transparent.
			ht2 _ d*insHt//nxtHt.
			space1 _ Morph newBounds: (0@0 extent: 30@(insHt-ht2))
                                        color: ((insHt-ht2) > (insHt//2+1) ifTrue: [c1] ifFalse: [c2]).
			self privateAddMorph: space1 atIndex: (i+1 max: 1).
			space2 _ Morph newBounds: (0@0 extent: 30@ht2)
                                        color: (ht2 > (insHt//2+1) ifTrue: [c1] ifFalse: [c2]).
			self privateAddMorph: space2 atIndex: (i+3 min: submorphs size+1).

"Transcript show: 'at:' ; show: (i+1 max:1) ; show: ' and at:' ; show: (i+3 min: submorphs size+1);cr;
	show: 'i=' ; show: i ; show: ' insHt=' ; show: insHt ; show:' ht2=' ; show: ht2 ; cr ; cr .
"
			]
		ifFalse:
			[self stopSteppingSelector: #trackDropZones.
			"self removeSpaces."
			self initializeView.
			]!]lang[(341 34 175 10 16 5 57 15 3 3 5 8 1567)0,5,0,5,0,5,0,5,0,5,0,5,0! !

